var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _CodeceptjsStringifyExtension_instances, _CodeceptjsStringifyExtension_formatAsJSLiteral, _CodeceptjsStringifyExtension_appendStepType, _CodeceptjsStringifyExtension_appendNavigateStep, _CodeceptjsStringifyExtension_appendViewportStep, _CodeceptjsStringifyExtension_appendClickStep, _CodeceptjsStringifyExtension_appendKeyDownStep, _CodeceptjsStringifyExtension_appendKeyUpStep, _CodeceptjsStringifyExtension_appendScrollStep, _CodeceptjsStringifyExtension_appendDoubleClickStep, _CodeceptjsStringifyExtension_appendHoverStep, _CodeceptjsStringifyExtension_appendWaitForElementStep;
import { PuppeteerStringifyExtension, StepType, } from '@puppeteer/replay';
import { SupportedKeys } from './types';
export class CodeceptjsStringifyExtension extends PuppeteerStringifyExtension {
    constructor() {
        super(...arguments);
        _CodeceptjsStringifyExtension_instances.add(this);
    }
    async beforeAllSteps(out, flow) {
        out.appendLine(`Feature('${__classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_formatAsJSLiteral).call(this, flow.title)}');

      Before(() => {

      });
      
      `);
        out.appendLine(`Scenario((${__classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_formatAsJSLiteral).call(this, flow.title)}), async ({ I }) => {
          `)
            .startBlock();
    }
    async afterAllSteps(out) {
        out.appendLine('});').endBlock();
    }
    async stringifyStep(out, step, flow) {
        __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendStepType).call(this, out, step, flow);
    }
    getSelector(selectors, flow) {
        // Remove Aria selectors
        const nonAriaSelectors = this.filterArrayByString(selectors, 'aria/');
        let preferredSelector;
        // Give preference to user selector
        if (flow && flow.selectorAttribute) {
            preferredSelector = this.filterArrayByString(nonAriaSelectors, flow.selectorAttribute);
        }
        if (preferredSelector && preferredSelector[0]) {
            return `${__classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_formatAsJSLiteral).call(this, Array.isArray(preferredSelector[0])
                ? preferredSelector[0][0]
                : preferredSelector[0])}`;
        }
        else {
            return `${__classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_formatAsJSLiteral).call(this, Array.isArray(nonAriaSelectors[0])
                ? nonAriaSelectors[0][0]
                : nonAriaSelectors[0])}`;
        }
    }
    filterArrayByString(selectors, filterValue) {
        return selectors.filter((selector) => filterValue === 'aria/'
            ? !selector[0].includes(filterValue)
            : selector[0].includes(filterValue));
    }
    logStepsNotImplemented(step) {
        console.log(`Warning: CodeceptJS Chrome Recorder does not handle migration of types ${step.type}.`);
    }
}
_CodeceptjsStringifyExtension_instances = new WeakSet(), _CodeceptjsStringifyExtension_formatAsJSLiteral = function _CodeceptjsStringifyExtension_formatAsJSLiteral(value) {
    return JSON.stringify(value);
}, _CodeceptjsStringifyExtension_appendStepType = function _CodeceptjsStringifyExtension_appendStepType(out, step, flow) {
    switch (step.type) {
        case StepType.SetViewport:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendViewportStep).call(this, out, step);
        case StepType.Navigate:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendNavigateStep).call(this, out, step);
        case StepType.Click:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendClickStep).call(this, out, step, flow);
        case StepType.KeyDown:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendKeyDownStep).call(this, out, step);
        case StepType.KeyUp:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendKeyUpStep).call(this, out, step);
        case StepType.Scroll:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendScrollStep).call(this, out, step, flow);
        case StepType.DoubleClick:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendDoubleClickStep).call(this, out, step, flow);
        case StepType.Hover:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendHoverStep).call(this, out, step, flow);
        case StepType.WaitForElement:
            return __classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_appendWaitForElementStep).call(this, out, step, flow);
        default:
            return this.logStepsNotImplemented(step);
    }
}, _CodeceptjsStringifyExtension_appendNavigateStep = function _CodeceptjsStringifyExtension_appendNavigateStep(out, step) {
    out.appendLine(`I.amOnPage(${__classPrivateFieldGet(this, _CodeceptjsStringifyExtension_instances, "m", _CodeceptjsStringifyExtension_formatAsJSLiteral).call(this, step.url)})`);
}, _CodeceptjsStringifyExtension_appendViewportStep = function _CodeceptjsStringifyExtension_appendViewportStep(out, step) {
    out.appendLine(`I.resizeWindow(${step.width}, ${step.height})`);
}, _CodeceptjsStringifyExtension_appendClickStep = function _CodeceptjsStringifyExtension_appendClickStep(out, step, flow) {
    const domSelector = this.getSelector(step.selectors, flow);
    const hasRightButton = step.button && step.button === 'secondary';
    if (domSelector) {
        hasRightButton
            ? out.appendLine(`I.rightClick(${domSelector})`)
            : out.appendLine(`I.click(${domSelector})`);
    }
    else {
        console.log(`Warning: The click on ${step.selectors} was not able to export to CodeceptJS. Please adjust selectors and try again`);
    }
}, _CodeceptjsStringifyExtension_appendKeyDownStep = function _CodeceptjsStringifyExtension_appendKeyDownStep(out, step) {
    const pressedKey = step.key.toLowerCase();
    if (pressedKey in SupportedKeys) {
        const keyValue = SupportedKeys[pressedKey];
        out.appendLine(`I.pressKeyDown('${keyValue}')`);
    }
}, _CodeceptjsStringifyExtension_appendKeyUpStep = function _CodeceptjsStringifyExtension_appendKeyUpStep(out, step) {
    const pressedKey = step.key.toLowerCase();
    if (pressedKey in SupportedKeys) {
        const keyValue = SupportedKeys[pressedKey];
        out.appendLine(`I.pressKeyUp('${keyValue}')`);
    }
}, _CodeceptjsStringifyExtension_appendScrollStep = function _CodeceptjsStringifyExtension_appendScrollStep(out, step, flow) {
    if ('selectors' in step) {
        const domSelector = this.getSelector(step.selectors, flow);
        out.appendLine(`I.scrollTo(${domSelector}, 0, 0)`);
    }
    else {
        out.appendLine(`I.scrollTo(${step.x}, ${step.y})`);
    }
}, _CodeceptjsStringifyExtension_appendDoubleClickStep = function _CodeceptjsStringifyExtension_appendDoubleClickStep(out, step, flow) {
    const domSelector = this.getSelector(step.selectors, flow);
    if (domSelector) {
        out.appendLine(`I.doubleClick(${domSelector})`);
    }
    else {
        console.log(`Warning: The click on ${step.selectors} was not able to be exported to CodeceptJS. Please adjust your selectors and try again.`);
    }
}, _CodeceptjsStringifyExtension_appendHoverStep = function _CodeceptjsStringifyExtension_appendHoverStep(out, step, flow) {
    const domSelector = this.getSelector(step.selectors, flow);
    if (domSelector) {
        out.appendLine(`I.moveCursorTo(${domSelector}, 0, 0)`);
    }
    else {
        console.log(`Warning: The Hover on ${step.selectors} was not able to be exported to CodeceptJS. Please adjust your selectors and try again.`);
    }
}, _CodeceptjsStringifyExtension_appendWaitForElementStep = function _CodeceptjsStringifyExtension_appendWaitForElementStep(out, step, flow) {
    const domSelector = this.getSelector(step.selectors, flow);
    let assertionStatement;
    if (domSelector) {
        out.appendLine(`
      I.waitForElement(${domSelector})`);
    }
    else {
        console.log(`Warning: The WaitForElement on ${step.selectors} was not able to be exported to CodeceptJS. Please adjust your selectors and try again.`);
    }
};
